Create design autofill job
Brand templates were migrated to use a new ID format in September 2025. If your integration stores brand template IDs, you'll need to migrate to use the new IDs. Old brand template IDs will continue to be accepted for 6 months to give you time to migrate to the new IDs.
To use this API, your integration must act on behalf of a user that's a member of a Canva Enterprise(opens in a new tab or window) organization.
Starts a new asynchronous job to autofill a Canva design using a brand template and input data.
To get a list of input data fields, use the Get brand template dataset API.
Available data field types to autofill include:
-
Images
-
Text
-
Charts
Chart data fields are a preview feature. There might be unannounced breaking changes to this feature which won't produce a new API version.
For more information on the workflow for using asynchronous jobs, see API requests and responses. You can check the status and get the results of autofill jobs created with this API using the Get design autofill job API.
HTTP method and URL path
https://api.canva.com /rest /v1 /autofillsThis operation is rate limited to 60 requests per minute for each user of your integration.
Authentication and authorization
This endpoint requires a valid access token that acts on behalf of a user.
Scopes
The access token must have all the following scopes (permissions):
design:content:write
Header parameters
Content-TypestringIndicates the media type of the information sent in the request. This must be set to application/json.
For example: Content-Type: application/json
Body parameters
brand_template_idstringID of the input brand template.
dataobjectData object containing the data fields and values to autofill.
<KEY>object of DatasetValuesThe data field to autofill.
{"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": true},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": false},{"type": "date"}]}]}}}
If the data field is an image field.
typestringAvailable values: The only valid value is image.
asset_idstringasset_id of the image to insert into the template element.
If the data field is a text field.
typestringAvailable values: The only valid value is text.
textstringText to insert into the template element.
If the data field is a chart.
Note the following behavior:
- If
column_configsis not provided, the first row is assumed to contain column headers where applicable. numbercells with formatting metadata are not currently supported for autofill and will result in an error response.mediacells are not supported for chart autofill and will result in an error response.
Chart data fields are a preview feature. There might be unannounced breaking changes to this feature which won't produce a new API version.
typestringAvailable values: The only valid value is chart.
chart_dataDataTableTabular data, structured in rows of cells.
- Each cell must have a data type configured.
- All rows must have the same number of cells.
- The number of entries in
column_configsmust match the number of columns in the data. - Maximum of 100 rows and 20 columns.
Chart data fields are a preview feature. There might be unannounced breaking changes to this feature which won't produce a new API version.
rowsDataTableRow[]Rows of data.
Maximum items: 100
cellsDataTableCell[]Cells of data in row.
All rows must have the same number of cells.
Maximum items: 20
A string tabular data cell.
typestringAvailable values: The only valid value is string.
valuestringA number tabular data cell.
typestringAvailable values: The only valid value is number.
valuenumbermetadataNumberCellMetadataFormatting metadata for number cells.
formattingstringFormatting pattern using Office Open XML Format.
These patterns control how numbers are displayed to users, including currency symbols, decimal places, and separators.
A boolean tabular data cell.
typestringAvailable values: The only valid value is boolean.
valuebooleanA date tabular data cell.
Specified as a Unix timestamp (in seconds since the Unix Epoch).
typestringAvailable values: The only valid value is date.
valueintegerCell containing a media collection.
typestringAvailable values: The only valid value is media.
valueDataTableMedia[]Media collection values.
Provide an empty array for an empty cell.
Maximum items: 20
Options for uploading an image asset.
typestringAvailable values: The only valid value is image_upload.
urlstringThe URL of the image file to upload. This can be an external URL or a data URL.
thumbnail_urlstringThe URL of a thumbnail image to display while the image is queued for upload. This can be an external URL or a data URL.
mime_typestringThe MIME type of an image file that's supported by Canva's backend.
Available values:
image/jpegimage/heicimage/pngimage/svg+xmlimage/webpimage/tiff
ai_disclosurestringA disclosure identifying if the app generated this media asset using AI.
Available values:
app_generated: App creates or significantly alters content using AInone: No AI involvement in creation or alteration
widthintegerThe width of the image in pixels.
heightintegerThe height of the image in pixels.
Options for uploading a video asset.
typestringAvailable values: The only valid value is video_upload.
urlstringThe URL of the video file to upload.
thumbnail_image_urlstringThe URL of a thumbnail image to use as a fallback if thumbnailVideoUrl isn't provided. This can be an external URL or a data URL.
mime_typestringThe MIME type of a video file that's supported by Canva's backend.
Available values:
video/avivideo/x-msvideoimage/gif: GIFs are treated as videos, not images.video/x-m4vvideo/x-matroskavideo/quicktimevideo/mp4video/mpegvideo/webmapplication/json: Used for Lottie files.
ai_disclosurestringA disclosure identifying if the app generated this media asset using AI.
Available values:
app_generated: App creates or significantly alters content using AInone: No AI involvement in creation or alteration
thumbnail_video_urlstringThe URL of a thumbnail video to display while the video is queued for upload.
widthintegerThe width of the video in pixels.
heightintegerThe height of the video in pixels.
column_configsColumnConfig[]Column definitions with names and data types.
typestringExpected data type for cells in this column.
Available values:
string: String datanumber: Numeric datadate: Date databoolean: Boolean datamedia: Media data (such as images, videos, or combinations of both)variant: Mixed data types (use where the column contains cells of a combination of data types)
namestringName for the column, displayed as header text.
titlestringTitle to use for the autofilled design.
If no design title is provided, the autofilled design will have the same title as the brand template.
Minimum length: 1
Maximum length: 255
Example request
Examples for using the /v1/autofills endpoint:
curl --request POST 'https://api.canva.com/rest/v1/autofills' \--header 'Authorization: Bearer {token}' \--header 'Content-Type: application/json' \--data '{"brand_template_id": "DAFVztcvd9z","title": "string","data": {"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": true},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": false},{"type": "date"}]}]}}}}'
const fetch = require("node-fetch");fetch("https://api.canva.com/rest/v1/autofills", {method: "POST",headers: {"Authorization": "Bearer {token}","Content-Type": "application/json",},body: JSON.stringify({"brand_template_id": "DAFVztcvd9z","title": "string","data": {"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": true},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": false},{"type": "date"}]}]}}}}),}).then(async (response) => {const data = await response.json();console.log(data);}).catch(err => console.error(err));
import java.io.IOException;import java.net.URI;import java.net.http.*;public class ApiExample {public static void main(String[] args) throws IOException, InterruptedException {HttpRequest request = HttpRequest.newBuilder().uri(URI.create("https://api.canva.com/rest/v1/autofills")).header("Authorization", "Bearer {token}").header("Content-Type", "application/json").method("POST", HttpRequest.BodyPublishers.ofString("{\"brand_template_id\": \"DAFVztcvd9z\", \"title\": \"string\", \"data\": {\"cute_pet_image_of_the_day\": {\"type\": \"image\", \"asset_id\": \"Msd59349ff\"}, \"cute_pet_witty_pet_says\": {\"type\": \"text\", \"text\": \"It was like this when I got here!\"}, \"cute_pet_sales_chart\": {\"type\": \"chart\", \"chart_data\": {\"column_configs\": [{\"name\": \"Geographic Region\", \"type\": \"string\"}, {\"name\": \"Sales (millions AUD)\", \"type\": \"number\"}, {\"name\": \"Target (millions AUD)\", \"type\": \"number\"}, {\"name\": \"Target met?\", \"type\": \"boolean\"}, {\"name\": \"Date met\", \"type\": \"date\"}], \"rows\": [{\"cells\": [{\"type\": \"string\", \"value\": \"Asia Pacific\"}, {\"type\": \"number\", \"value\": 10.2}, {\"type\": \"number\", \"value\": 10}, {\"type\": \"boolean\", \"value\": true}, {\"type\": \"date\", \"value\": 1721944387}]}, {\"cells\": [{\"type\": \"string\", \"value\": \"EMEA\"}, {\"type\": \"number\", \"value\": 13.8}, {\"type\": \"number\", \"value\": 14}, {\"type\": \"boolean\", \"value\": false}, {\"type\": \"date\"}]}]}}}}")).build();HttpResponse<String> response = HttpClient.newHttpClient().send(request,HttpResponse.BodyHandlers.ofString());System.out.println(response.body());}}
import requestsheaders = {"Authorization": "Bearer {token}","Content-Type": "application/json"}data = {"brand_template_id": "DAFVztcvd9z","title": "string","data": {"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": True},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": False},{"type": "date"}]}]}}}}response = requests.post("https://api.canva.com/rest/v1/autofills",headers=headers,json=data)print(response.json())
using System.Net.Http;var client = new HttpClient();var request = new HttpRequestMessage{Method = HttpMethod.Post,RequestUri = new Uri("https://api.canva.com/rest/v1/autofills"),Headers ={{ "Authorization", "Bearer {token}" },},Content = new StringContent("{\"brand_template_id\": \"DAFVztcvd9z\", \"title\": \"string\", \"data\": {\"cute_pet_image_of_the_day\": {\"type\": \"image\", \"asset_id\": \"Msd59349ff\"}, \"cute_pet_witty_pet_says\": {\"type\": \"text\", \"text\": \"It was like this when I got here!\"}, \"cute_pet_sales_chart\": {\"type\": \"chart\", \"chart_data\": {\"column_configs\": [{\"name\": \"Geographic Region\", \"type\": \"string\"}, {\"name\": \"Sales (millions AUD)\", \"type\": \"number\"}, {\"name\": \"Target (millions AUD)\", \"type\": \"number\"}, {\"name\": \"Target met?\", \"type\": \"boolean\"}, {\"name\": \"Date met\", \"type\": \"date\"}], \"rows\": [{\"cells\": [{\"type\": \"string\", \"value\": \"Asia Pacific\"}, {\"type\": \"number\", \"value\": 10.2}, {\"type\": \"number\", \"value\": 10}, {\"type\": \"boolean\", \"value\": true}, {\"type\": \"date\", \"value\": 1721944387}]}, {\"cells\": [{\"type\": \"string\", \"value\": \"EMEA\"}, {\"type\": \"number\", \"value\": 13.8}, {\"type\": \"number\", \"value\": 14}, {\"type\": \"boolean\", \"value\": false}, {\"type\": \"date\"}]}]}}}}",Encoding.UTF8,"application/json"),};using (var response = await client.SendAsync(request)){response.EnsureSuccessStatusCode();var body = await response.Content.ReadAsStringAsync();Console.WriteLine(body);};
package mainimport ("fmt""io""net/http""strings")func main() {payload := strings.NewReader(`{"brand_template_id": "DAFVztcvd9z","title": "string","data": {"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": true},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": false},{"type": "date"}]}]}}}}`)url := "https://api.canva.com/rest/v1/autofills"req, _ := http.NewRequest("POST", url, payload)req.Header.Add("Authorization", "Bearer {token}")req.Header.Add("Content-Type", "application/json")res, _ := http.DefaultClient.Do(req)defer res.Body.Close()body, _ := io.ReadAll(res.Body)fmt.Println(string(body))}
$curl = curl_init();curl_setopt_array($curl, array(CURLOPT_URL => "https://api.canva.com/rest/v1/autofills",CURLOPT_CUSTOMREQUEST => "POST",CURLOPT_RETURNTRANSFER => true,CURLOPT_HTTPHEADER => array('Authorization: Bearer {token}','Content-Type: application/json',),CURLOPT_POSTFIELDS => json_encode(["brand_template_id" => "DAFVztcvd9z","title" => "string","data" => ["cute_pet_image_of_the_day" => ["type" => "image","asset_id" => "Msd59349ff"],"cute_pet_witty_pet_says" => ["type" => "text","text" => "It was like this when I got here!"],"cute_pet_sales_chart" => ["type" => "chart","chart_data" => ["column_configs" => [["name" => "Geographic Region","type" => "string"],["name" => "Sales (millions AUD)","type" => "number"],["name" => "Target (millions AUD)","type" => "number"],["name" => "Target met?","type" => "boolean"],["name" => "Date met","type" => "date"]],"rows" => [["cells" => [["type" => "string","value" => "Asia Pacific"],["type" => "number","value" => 10.2],["type" => "number","value" => 10],["type" => "boolean","value" => true],["type" => "date","value" => 1721944387]]],["cells" => [["type" => "string","value" => "EMEA"],["type" => "number","value" => 13.8],["type" => "number","value" => 14],["type" => "boolean","value" => false],["type" => "date"]]]]]]]])));$response = curl_exec($curl);$err = curl_error($curl);curl_close($curl);if (empty($err)) {echo $response;} else {echo "Error: " . $err;}
require 'net/http'require 'uri'url = URI('https://api.canva.com/rest/v1/autofills')http = Net::HTTP.new(url.host, url.port)http.use_ssl = truerequest = Net::HTTP::Post.new(url)request['Authorization'] = 'Bearer {token}'request['Content-Type'] = 'application/json'request.body = <<REQUEST_BODY{"brand_template_id": "DAFVztcvd9z","title": "string","data": {"cute_pet_image_of_the_day": {"type": "image","asset_id": "Msd59349ff"},"cute_pet_witty_pet_says": {"type": "text","text": "It was like this when I got here!"},"cute_pet_sales_chart": {"type": "chart","chart_data": {"column_configs": [{"name": "Geographic Region","type": "string"},{"name": "Sales (millions AUD)","type": "number"},{"name": "Target (millions AUD)","type": "number"},{"name": "Target met?","type": "boolean"},{"name": "Date met","type": "date"}],"rows": [{"cells": [{"type": "string","value": "Asia Pacific"},{"type": "number","value": 10.2},{"type": "number","value": 10},{"type": "boolean","value": true},{"type": "date","value": 1721944387}]},{"cells": [{"type": "string","value": "EMEA"},{"type": "number","value": 13.8},{"type": "number","value": 14},{"type": "boolean","value": false},{"type": "date"}]}]}}}}REQUEST_BODYresponse = http.request(request)puts response.read_body
Success response
If successful, the endpoint returns a 200 response with a JSON body with the following parameters:
jobDesignAutofillJobDetails about the autofill job.
idstringID of the asynchronous job that is creating the design using the provided data.
statusstringStatus of the design autofill job.
Available values:
in_progresssuccessfailed
resultDesignAutofillJobResultResult of the design autofill job. Only present if job status is success.
Design has been created and saved to user's root folder.
typestringAvailable values: The only valid value is create_design.
designDesignSummaryBasic details about the design, such as the design's ID, title, and URL.
idstringThe design ID.
urlsDesignLinksA temporary set of URLs for viewing or editing the design.
edit_urlstringA temporary editing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.
This is not a permanent URL, it is only valid for 30 days.
view_urlstringA temporary viewing URL for the design. This URL is only accessible to the user that made the API request, and is designed to support return navigation workflows.
This is not a permanent URL, it is only valid for 30 days.
created_atintegerWhen the design was created in Canva, as a Unix timestamp (in seconds since the Unix Epoch).
updated_atintegerWhen the design was last updated in Canva, as a Unix timestamp (in seconds since the Unix Epoch).
titlestringThe design title.
urlstringURL of the design.
thumbnailThumbnailA thumbnail image representing the object.
widthintegerThe width of the thumbnail image in pixels.
heightintegerThe height of the thumbnail image in pixels.
urlstringA URL for retrieving the thumbnail image. This URL expires after 15 minutes. This URL includes a query string that's required for retrieving the thumbnail.
page_countintegerThe total number of pages in the design. Some design types don't have pages (for example, Canva docs).
errorAutofillErrorIf the autofill job fails, this object provides details about the error.
codestringAvailable values:
autofill_errorthumbnail_generation_errorcreate_design_errordesign_approval_error
messagestringA human-readable description of what went wrong.
Example responses
In progress job
{"job": {"id": "450a76e7-f96f-43ae-9c37-0e1ce492ac72","status": "in_progress"}}
Successfully completed job
{"job": {"id": "450a76e7-f96f-43ae-9c37-0e1ce492ac72","status": "success","result": {"type": "create_design","design": {"id": "DAFVztcvd9z","title": "My summer holiday","url": "https://www.canva.com/design/DAFVztcvd9z/edit","urls": {"edit_url": "https://www.canva.com/api/ekimus8HTvsdf&/edit","view_url": "https://www.canva.com/api/eylPinTv358hYb8n1U4/view"},"thumbnail": {"width": 595,"height": 335,"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?<query-string>"},"created_at": 1586734043,"updated_at": 1586734043}}}}
Failed job
{"job": {"id": "450a76e7-f96f-43ae-9c37-0e1ce492ac72","status": "failed","error": {"code": "autofill_error","message": "Error autofilling design from brand template"}}}
Error responses
400 Bad Request
codestringA short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.
messagestringA human-readable description of what went wrong.
Example error response
{"code": "bad_request_params","message": "Design title invalid"}
403 Forbidden
codestringA short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.
messagestringA human-readable description of what went wrong.
Example error response
{"code": "permission_denied","message": "Not allowed to access brand template with id '{brandTemplateId}'"}
404 Not Found
codestringA short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see Error responses.
messagestringA human-readable description of what went wrong.
Example error response
{"code": "not_found","message": "Brand template with id '{brandTemplateId}' not found"}